package test;

import java.io.ByteArrayOutputStream;
import java.text.DateFormat;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Date;
import java.util.Iterator;
import java.util.StringTokenizer;
import com.borland.enterprise.xml.api.IAccessibleBean;
import com.borland.enterprise.xml.api.ICmpField;
import com.borland.enterprise.xml.api.IEjbRef;
import com.borland.enterprise.xml.api.IEnterpriseBean;
import com.borland.enterprise.xml.api.IEntityBean;
import com.borland.enterprise.xml.api.IFinder;
import com.borland.enterprise.xml.api.IMessageDrivenBean;
import com.borland.enterprise.xml.api.IResourceEnvRef;
import com.borland.enterprise.xml.api.IResourceRef;
import com.borland.enterprise.xml.api.ISessionBean;
import com.borland.enterprise.xml.api.enum.EnumCmpVersion;
import com.borland.enterprise.xml.api.enum.EnumPersistenceType;
import com.borland.jbuilder.build.BuildMessage;
import com.borland.jbuilder.build.BuildReport;
import com.borland.jbuilder.enterprise.ejb.AbstractDescriptorConversion;
import com.borland.jbuilder.enterprise.ejb.DeploymentDescriptor;
import com.borland.jbuilder.enterprise.ejb.XMLNode;
import com.borland.jbuilder.enterprise.ejb.XMLPrinter;
import com.borland.jbuilder.jot.JotMethod;
import com.borland.jbuilder.node.EJBGRPFileNode;
import com.borland.jbuilder.node.JBProject;
import com.borland.jbuilder.node.JavaFileNode;
import com.borland.primetime.ide.MessageCategory;
import com.borland.primetime.ide.MessageView;
import com.borland.primetime.util.AssertionException;
import com.borland.primetime.util.Strings;
import com.borland.jbuilder.enterprise.ejb.EjbGrpUtils;
import com.borland.jbuilder.enterprise.ejb.EjbReference;
import com.borland.primetime.ide.Context;


/**
 * <p>Titre : </p>
 * <p>Description : </p>
 * <p>Copyright : Copyright (c) 2003</p>
 * <p>Socit : </p>
 * @author non attribuable
 * @version 1.0
 */

public class JonasAbstractDescriptorConversion extends AbstractDescriptorConversion
{

   /**
    * Constructor
    *
    * @param adeploymentdescriptor Deployment descriptors from a EJB Module file.
    * @param ejbgrpfilenode The EJB Module where the dds parameter was obtained.
    * @param buildreport Where to post warning or error messages, or null.
    */
   public JonasAbstractDescriptorConversion(DeploymentDescriptor adeploymentdescriptor[],
                                            EJBGRPFileNode ejbgrpfilenode,
                                            BuildReport buildreport)
   {
      super(adeploymentdescriptor, ejbgrpfilenode, buildreport);
   }

   /**
    * Creates the iEjbJar class variable from the Borland deployment descriptors
    * provided when this class was constructed.
    *
    * @param flag True if want build error message output and specified a
    * BuildReport object in the constructor.
    *
    * @return True if successful.
    */
   protected boolean createInterfaceFromDescriptors(boolean flag)
   {
      boolean flag1 = super.createInterfaceFromDescriptors(flag);
      for(int i = 0; i < super.dds.length; i++)
      {
         if(super.dds[i].getTimestamp() > super.descriptorDate)
         {
            super.descriptorDate = super.dds[i].getTimestamp();
         }
      }
      return flag1;
   }

   /**
    * Verify the deployment descriptors and append any warning/error messages to
    * the given MessageView using the given category. Do not modify the EJB Module.
    *
    * @param mv MessageView to use for any warnings/errors.
    * @param mc MessageCategory of mv to use.
    *
    * @throws java.lang.Exception Fatal error conversion error encountered.
    */
   public void verifyDeploymentDescriptors(MessageView messageview, MessageCategory messagecategory) throws
      java.lang.Exception
   {
      int i = 0;
      int j = 0;
      DateFormat dateformat = DateFormat.getDateTimeInstance(2, 1);
      try
      {
         super.report = new BuildReport();
         messageview.addMessage(messagecategory, "");
         String s = dateformat.format(new Date());
         //s = Strings.format(Res.l, s);
         s = Strings.format("Message 1", s);
         messageview.addMessage(messagecategory, s);
         convert(false, true, false);
         BuildMessage abuildmessage[] = super.report.getAllMessages();
         if(abuildmessage != null)
         {
            for(int k = 0; k < abuildmessage.length; k++)
            {
               if(abuildmessage[k].isError())
               {
                  //s = Strings.format(Res.n, abuildmessage[k].getMessage(), String.valueOf(abuildmessage[k].getLineNumber()));
                  s = Strings.format("Message 2", abuildmessage[k].getMessage(),
                                     String.valueOf(abuildmessage[k].getLineNumber()));
                  continue;
               }
               if(abuildmessage[k].isWarning())
               {
                  //s = Strings.format(Res.e, abuildmessage[k].getMessage(), String.valueOf(abuildmessage[k].getLineNumber()));
                  s = Strings.format("Message 3", abuildmessage[k].getMessage(),
                                     String.valueOf(abuildmessage[k].getLineNumber()));
                  messageview.addMessage(messagecategory, s);
               }
            }

         }
         //s = Strings.format(Res.m, String.valueOf(i), String.valueOf(j));
         s = Strings.format("Message 4", String.valueOf(i), String.valueOf(j));
         messageview.addMessage(messagecategory, s);
      }
      catch(Exception exception)
      {
         throw new AssertionException(exception.getMessage());
      }
   }

   /**
    * This routine is called by convert() to initiate the generation of the
    * descriptors from information in class variables. It creates zero or more
    * DeploymentDescriptor objects which are to be added to the given ArrayList.
    * The entry for ejb-jar.xml is already there.
    *
    * @param ddList Where to place generated DeploymentDescriptor objects.
    *
    * @throws java.lang.Exception Fatal error conversion error encountered.
    */
   protected void generate(ArrayList ddList) throws java.lang.Exception
   {
      XMLNode nodeEntity = null;
      Collection collection = null;
      Collection collection1 = null;
      XMLNode nodeEjbJar = null;
      Iterator iterator = null;
      IEnterpriseBean ienterprisebean = null;
      IEntityBean ientitybean = null;
      IEntityBean ientitybean1 = null;
      IEnterpriseBean ienterprisebean1 = null;
      ISessionBean isessionbean1 = null;
      IMessageDrivenBean imessagedrivenbean1 = null;
      XMLNode xmlnodeMDB = null;

      try
      {
         collection = super.iEjbJar.getEjbList();

         // Creation du noeud racine du descripteur
         nodeEjbJar = new XMLNode(null, "jonas-ejb-jar");
         int l = 0;
         if(collection != null)
         {
            iterator = collection.iterator();
            do
            {
               if(!iterator.hasNext())
               {
                  break;
               }
               ienterprisebean = (IEnterpriseBean) iterator.next();
               if(ienterprisebean instanceof IEntityBean)
               {
                  ientitybean = (IEntityBean) ienterprisebean;
                  if(ientitybean.getPersistenceTypeEnum() == EnumPersistenceType.CONTAINER &&
                     !ientitybean.getCmpFieldList().isEmpty())
                  {
                     l++;
                  }
               }
            }
            while(true);
            iterator = collection.iterator();
            do
            {
               if(!iterator.hasNext())
               {
                  break;
               }
               ienterprisebean1 = (IEnterpriseBean) iterator.next();
               //if(ienterprisebean1 instanceof IAccessibleBean)
               //{
                  //IAccessibleBean iaccessiblebean = (IAccessibleBean) ienterprisebean1;

                  // Si EJB SESSION
                  if(ienterprisebean1 instanceof ISessionBean)
                  {
                     isessionbean1 = (ISessionBean) ienterprisebean1;
                     XMLNode xmlnodeSession = new XMLNode(nodeEjbJar, "jonas-session");

                     // Ajout ejb-name
                     new XMLNode(xmlnodeSession, "ejb-name", isessionbean1.getEjbName());

                     // Ajout jndi-name
                     String jndiName = isessionbean1.getJndiHomeName();
                     if(jndiName != null && jndiName.length() > 0)
                     {
                        new XMLNode(xmlnodeSession, "jndi-name", jndiName);
                     }

                     // Ajout des elements communs  tous les EJB
                     generateResourceDescriptor(ienterprisebean1, xmlnodeSession);
                     generateResourceEnvDescriptor(ienterprisebean1, xmlnodeSession);
                     generateEjbRefDescriptor(ienterprisebean1, xmlnodeSession);

                     // Ajout de session timeout
                     String sessionTimeOut = isessionbean1.getTimeout();
                     if(sessionTimeOut != null && sessionTimeOut.length() > 0)
                     {
                        new XMLNode(xmlnodeSession, "session-timeout", sessionTimeOut);
                     }
                  }

                  // Si MESSAGE DRIVEN BEAN
                  else if(ienterprisebean1 instanceof IMessageDrivenBean)
                  {
                     imessagedrivenbean1 = (IMessageDrivenBean) ienterprisebean1;
                     xmlnodeMDB = new XMLNode(nodeEjbJar, "jonas-message-driven");

                     // Ajout ejb-name
                     new XMLNode(xmlnodeMDB, "ejb-name", imessagedrivenbean1.getEjbName());

                     // Ajout jonas-message-driven-destination
                     XMLNode xmlNodeDestination = new XMLNode(xmlnodeMDB, "jonas-message-driven-destination");
                     String destinationName = imessagedrivenbean1.getMessageDrivenDestinationName();
                     if(destinationName != null && destinationName.length() > 0)
                     {
                        new XMLNode(xmlNodeDestination, "jndi-name", destinationName);
                     }
                     else
                     {
                        new XMLNode(xmlNodeDestination, "jndi-name");
                     }

                     // Ajout des elements communs  tous les EJB
                     generateResourceDescriptor(ienterprisebean1, xmlnodeMDB);
                     generateResourceEnvDescriptor(ienterprisebean1, xmlnodeMDB);
                     generateEjbRefDescriptor(ienterprisebean1, xmlnodeMDB);
                  }

                  // Si EJB ENTITY
                  else if(ienterprisebean1 instanceof IEntityBean)
                  {
                     ientitybean1 = (IEntityBean) ienterprisebean1;

                     nodeEntity = new XMLNode(nodeEjbJar, "jonas-entity");

                     new XMLNode(nodeEntity, "ejb-name", ienterprisebean1.getEjbName());

                     String jndiName = ((IAccessibleBean)ienterprisebean1).getJndiHomeName();
                     if(jndiName != null && jndiName.length() > 0)
                     {
                        new XMLNode(nodeEntity, "jndi-name", jndiName);
                     }

                     // Ajout des elements communs  tous les EJB
                     generateResourceDescriptor(ienterprisebean1, nodeEntity);
                     generateResourceEnvDescriptor(ienterprisebean1, nodeEntity);
                     generateEjbRefDescriptor(ienterprisebean1, nodeEntity);

                     // Si EJB ENTITY BMP
                     if(ientitybean1.getPersistenceTypeEnum() == EnumPersistenceType.BEAN)
                     {
                        if(isModifiedPresent(ientitybean1))
                        {
                           new XMLNode(nodeEntity, "is-modified-method-name", "isModified");
                        }
                     }

                     // Si EJB ENTITY CMP
                     else if(ientitybean1.getPersistenceTypeEnum() == EnumPersistenceType.CONTAINER)
                     {
                        collection1 = ientitybean1.getCmpFieldList();
                        if(collection1 != null && !collection1.isEmpty())
                        {
                           // Ajout is-modified-method-name
                           if(isModifiedPresent(ientitybean1))
                           {
                              new XMLNode(nodeEntity, "is-modified-method-name", "isModified");
                           }

                           // Ajout shared
                           new XMLNode(nodeEntity, "shared", "false");

                           // Ajout jdbc-mapping
                           generateJdbcMappingDescriptor(ientitybean1, nodeEntity);
                        }
                     }
                  }
               //}
            }
            while(true);
         }
         String s = getEjbJarDocType();
         DeploymentDescriptor deploymentdescriptor = toDescriptor(nodeEjbJar, s, "jonas-ejb-jar.xml");
         ddList.add(deploymentdescriptor);
      }
      catch (Exception e)
      {
         e.printStackTrace();
         throw e;
      }
   }

   /**
    * Generates the descriptors for jonas-resource
    * @param ienterprisebean
    * @param xmlnode
    * @throws Exception
    */
   protected void generateResourceDescriptor(IEnterpriseBean ienterprisebean, XMLNode xmlnode) throws
      Exception
   {
      Collection collection = ienterprisebean.getResourceRefList();
      if(collection != null && !collection.isEmpty())
      {
         IResourceRef iresourceref;
         for(Iterator iterator = collection.iterator(); iterator.hasNext(); )
         {
            iresourceref = (IResourceRef) iterator.next();
            XMLNode xmlnode1 = new XMLNode(xmlnode, "jonas-resource");
            new XMLNode(xmlnode1, "res-ref-name", iresourceref.getResRefName());
            new XMLNode(xmlnode1, "jndi-name", iresourceref.getJndiName());
         }
      }
   }

   /**
    * Generates the descriptors for jonas-resource-env
    * @param ienterprisebean
    * @param xmlnode
    * @throws Exception
    */
   protected void generateResourceEnvDescriptor(IEnterpriseBean ienterprisebean, XMLNode xmlnode) throws
      Exception
   {
      XMLNode xmlnode1 = null;
      IResourceEnvRef iresourceenvref;
      Collection collection = ienterprisebean.getResourceEnvRefList();
      if(collection != null && !collection.isEmpty())
      {
         for(Iterator iterator = collection.iterator(); iterator.hasNext(); )
         {
            iresourceenvref = (IResourceEnvRef) iterator.next();
            xmlnode1 = new XMLNode(xmlnode, "jonas-resource-env");
            new XMLNode(xmlnode1, "resource-env-ref-name", iresourceenvref.getResourceEnvRefName());
            new XMLNode(xmlnode1, "jndi-name", iresourceenvref.getJndiName());

         }
      }
   }

   /**
    * Generates the descriptors for jonas-ejb-ref
    * @param ienterprisebean
    * @param xmlnode
    * @throws Exception
    */
   protected void generateEjbRefDescriptor(IEnterpriseBean ienterprisebean, XMLNode xmlnode) throws
      Exception
   {
      IEjbRef iEjbRef;
      XMLNode xmlnode1 = null;
      Collection collection = ienterprisebean.getEjbRefList();
      if(collection != null && !collection.isEmpty())
      {
         for(Iterator iterator = collection.iterator(); iterator.hasNext(); )
         {
            iEjbRef = (IEjbRef) iterator.next();
            xmlnode1 = new XMLNode(xmlnode, "jonas-ejb-ref");
            new XMLNode(xmlnode1, "ejb-ref-name", iEjbRef.getEjbRefName());
            new XMLNode(xmlnode1, "jndi-name", iEjbRef.getJndiName());
         }
      }
   }

   /**
    * Generates the descriptors for jdbc-mapping, making differences between
    * CMP 1 and 2
    * @param ienterprisebean
    * @param xmlnode
    * @throws Exception
    */
   protected void generateJdbcMappingDescriptor(IEntityBean ientitybean, XMLNode xmlnode) throws
      Exception
   {
      Collection collection = ientitybean.getCmpFieldList();
      Collection col = null;
      XMLNode nodeJdbcMapping = null;
      XMLNode nodeCmpField = null;
      XMLNode nodeFinderMethod = null;
      XMLNode nodeJonasMethod = null;
      XMLNode nodeMethodParams = null;
      ICmpField icmpfield = null;
      IFinder ifinder = null;
      String signatureMethod = null;
      String nomParam = null;
      StringTokenizer stringtokenizer = null;
      String nomMethode = null;
      int j1 = 0;
      int index = 0;
      int k1 = 0;
      boolean methodParams = true;

      if(collection != null && !collection.isEmpty())
      {
         nodeJdbcMapping = new XMLNode(xmlnode, "jdbc-mapping");
         new XMLNode(nodeJdbcMapping, "jndi-name", super.getBeanDataSourceName(ientitybean));

         // Ajout pour CMP 1.x
         if(ientitybean.getCmpVersionEnum() == EnumCmpVersion.ONE_X)
         {
            new XMLNode(nodeJdbcMapping, "jdbc-table-name", ientitybean.getTableName());
            new XMLNode(nodeJdbcMapping, "automatic-pk", "false");

            for(Iterator iterator = collection.iterator(); iterator.hasNext(); )
            {
               icmpfield = (ICmpField) iterator.next();
               nodeCmpField = new XMLNode(nodeJdbcMapping, "cmp-field-jdbc-mapping");
               new XMLNode(nodeCmpField, "field-name", icmpfield.getFieldName());
               new XMLNode(nodeCmpField, "jdbc-field-name", icmpfield.getColumnName());
            }
            col = ientitybean.getFinderList();
            if(col != null && !col.isEmpty())
            {
               for(Iterator iterator = col.iterator(); iterator.hasNext(); )
               {
                  nodeFinderMethod = new XMLNode(nodeJdbcMapping, "finder-method-jdbc-mapping");
                  ifinder = (IFinder) iterator.next();
                  nodeJonasMethod = new XMLNode(nodeFinderMethod, "jonas-method");
                  signatureMethod = ifinder.getMethodSignature();
                  new XMLNode(nodeFinderMethod, "jdbc-where-clause", ifinder.getWhereClause());

                  // Parser la chaine pour recuperer le nom de la methode et ses params
                  j1 = signatureMethod.indexOf('(');
                  if(j1 != -1 && signatureMethod.length() > j1 + 1)
                  {
                     nomMethode = signatureMethod.substring(0, j1).trim();
                     index = nomMethode.lastIndexOf(" ");
                     nomMethode = nomMethode.substring(index, nomMethode.length());
                     new XMLNode(nodeJonasMethod, "method-name", nomMethode);
                     for(stringtokenizer = new StringTokenizer(signatureMethod.substring(j1 + 1), ",)"); stringtokenizer.hasMoreTokens(); )
                     {
                        if(methodParams == true)
                        {
                           nodeMethodParams = new XMLNode(nodeJonasMethod, "method-params");
                           methodParams = false;
                        }
                        nomParam = stringtokenizer.nextToken().trim();
                        k1 = nomParam.indexOf(' ');
                        if(k1 != -1)
                        {
                           nomParam = nomParam.substring(0, k1);
                           if(nomParam.length() > 0)
                           {
                              nomParam = Class.forName(nomParam).getName();
                              new XMLNode(nodeMethodParams, "method-param", nomParam);
                           }
                        }
                     }
                  }
               }
            }
         }
      }
   }

   protected boolean isModifiedPresent(IEntityBean ientitybean)
   {
      JotMethod jotmethod = null;
      try
      {
         JBProject jbproject = getProject();
         JavaFileNode javafilenode = AbstractDescriptorConversion.getEjbNode(jbproject, ientitybean.getEjbClass());
         JotMethod ajotmethod[] = AbstractDescriptorConversion.getJotMethods(javafilenode);
         for(int l = 0; l < ajotmethod.length; l++)
         {
            jotmethod = ajotmethod[l];
            if(jotmethod.getName().equals("isModified") && jotmethod.getParameters().length == 0 &&
               jotmethod.getReturnType().getName().equals("boolean"))
            {
               boolean flag = true;
               return flag;
            }
         }
      }
      catch(Exception exception)
      {
         exception.printStackTrace();
      }
      return false;
   }

   /**
    *
    * @return
    */
   protected String getEjbJarDocType()
   {
      String s = "<!DOCTYPE jonas-ejb-jar PUBLIC \"-//ObjectWeb//DTD JOnAS 3.0//EN\" \"http://www.objectweb.org/jonas/dtds/jonas-ejb-jar_3_0.dtd\">";
      return s;
   }

   /**
    *
    * @param xmlnode
    * @param s
    * @param s1
    * @return
    * @throws Exception
    */
   protected DeploymentDescriptor toDescriptor(XMLNode xmlnode, String s, String s1) throws
      Exception
   {
      ByteArrayOutputStream bytearrayoutputstream = new ByteArrayOutputStream();
      try
      {
         XMLPrinter xmlprinter = new XMLPrinter(bytearrayoutputstream, "UTF-8");
         xmlprinter.println(s);
         xmlprinter.print(xmlnode);
      }
      finally
      {
         bytearrayoutputstream.close();
      }
      DeploymentDescriptor deploymentdescriptor = new DeploymentDescriptor(s1);
      deploymentdescriptor.setBytes(bytearrayoutputstream.toByteArray());
      deploymentdescriptor.setTimestamp(System.currentTimeMillis());
      return deploymentdescriptor;
   }

}