package test;

import com.borland.jbuilder.server.DeployService;
import com.borland.jbuilder.runtime.DeployListener;
import com.borland.jbuilder.node.JBProject;
import com.borland.primetime.ide.Browser;
import com.borland.primetime.vfs.ui.UrlChooser;
import java.util.ArrayList;
import com.borland.primetime.node.*;
import com.borland.primetime.vfs.*;
import com.borland.enterprise.util.Enum;
import com.borland.enterprise.xml.api.*;
import com.borland.enterprise.xml.api.enum.EnumCmpVersion;
import com.borland.enterprise.xml.api.enum.EnumPersistenceType;
import com.borland.jbuilder.enterprise.AbstractDeploymentDescriptor;
import com.borland.jbuilder.enterprise.EnterpriseUtils;
import com.borland.jbuilder.enterprise.ejb.EjbGrpUtils;
import com.borland.jbuilder.enterprise.ejb.EjbReference;
import com.borland.jbuilder.enterprise.ejb.ejbmodeler.xml.schema.SchemaTreeUtil;
import com.borland.jbuilder.node.EJBGRPFileNode;
import com.borland.jbuilder.runtime.ServerRunner;
import com.borland.jbuilder.runtime.JavaProcess;
import com.borland.primetime.runtime.RunConfiguration;
import com.borland.jbuilder.server.Server;
import com.borland.jbuilder.server.ServerLauncher;
//import com.borland.jbuilder.server.sybase.EASException;
//import com.borland.jbuilder.server.sybase.ui.EASPropertyTableModel;
import com.borland.primetime.node.FileNode;
import com.borland.primetime.node.Node;
import com.borland.primetime.properties.*;
import com.borland.primetime.vfs.*;
import java.io.*;
import java.net.InetAddress;
import java.net.UnknownHostException;
import java.util.*;
import com.borland.jbuilder.node.JarFileNode;
import com.borland.jbuilder.paths.PathSet;
import com.borland.jbuilder.paths.PathSetManager;

/**
 * <p>Titre : </p>
 * <p>Description : </p>
 * <p>Copyright : Copyright (c) 2003</p>
 * <p>Socit : </p>
 * @author non attribuable
 * @version 1.0
 */
public class JonasDeployService extends DeployService
{
   public JonasDeployService(JonasServer p_Server)
   {
      super(p_Server);
   }

   public void contextDeploy(Browser browser,
                             JBProject project,
                             java.util.ArrayList deployNodes,
                             int deployAction,
                             DeployListener deployListener)
   {
      // Mthode de deploiement pour le menu clic droit sur noeud
      String archivePath = null;
      String archiveExtension = null;
      String archiveName = null;
      Url urlNode = null;
      Url urlTarget = null;
      JarFileNode archiveNodeArray = null;
      Iterator deployableNodesList = null;
      int nbArchivesToDeploy = 0;
      int index = 0;
      boolean isEjbJar = false;
      boolean newDeployment = false;
      JonasLauncher jonasLauncher = (JonasLauncher)this.getServer().getSetupLauncher();
      JonasRun jRun = new JonasRun(project);
      Process process = null;


      try
      {
         for(deployableNodesList = deployNodes.iterator(); deployableNodesList.hasNext();)
         {
            if(deployAction == this.LIST_ACTION)
            {
               process = jRun.startJavaProcess(JonasRessource.get("JONAS_CLASS_ADMIN") + " " +
                                               JonasRessource.get("ADMIN_LIST_OPTION"),
                                               "");
               // Waits for the end of the process
               process.waitFor();
            }
            // Contains the node and his companion Node
            archiveNodeArray = (JarFileNode)deployableNodesList.next();
            archivePath = archiveNodeArray.getUrl().getFile();
            archiveName = archivePath.substring(archivePath.lastIndexOf("/") + 1);
            archiveExtension = archiveName.substring(archiveName.indexOf(".") + 1);
            urlNode = new Url("file", String.valueOf(archiveNodeArray.getUrl().getFile()));
            if(archiveExtension.equalsIgnoreCase(JarFileNode.EXTENSION))
            {
               // EjbJar
               isEjbJar = true;

               urlTarget = new Url("file",
                                   String.valueOf(this.getServer().getHomeDirectory().getFile()) +
                                   String.valueOf(File.separatorChar + "ejbjars" +
                                                  File.separatorChar + "autoload" +
                                                  File.separatorChar + archiveName));
            }
            else if(archiveExtension.equalsIgnoreCase(JarFileNode.WAR_EXTENSION))
            {
               // WAR
               urlTarget = new Url("file",
                                   String.valueOf(this.getServer().getHomeDirectory().getFile()) +
                                   String.valueOf(File.separatorChar + "webapps" +
                                                  File.separatorChar + "autoload" +
                                                  File.separatorChar + archiveName));
            }
            else if(archiveExtension.equalsIgnoreCase(JarFileNode.EAR_EXTENSION))
            {
               // EAR
               urlTarget = new Url("file",
                                   String.valueOf(this.getServer().getHomeDirectory().getFile()) +
                                   String.valueOf(File.separatorChar + "apps" +
                                                  File.separatorChar + "autoload" +
                                                  File.separatorChar + archiveName));
            }
            else if(archiveExtension.equalsIgnoreCase(JarFileNode.RAR_EXTENSION))
            {
               // RAR
               urlTarget = new Url("file",
                                   String.valueOf(this.getServer().getHomeDirectory().getFile()) +
                                   String.valueOf(File.separatorChar + "rars" +
                                                  File.separatorChar + "autoload" +
                                                  File.separatorChar + archiveName));
            }

            try
            {
               if(urlTarget != null)
               {
                  // IF DEPLOY or REDEPLOY ACTION
                  if(deployAction == this.DEPLOY_ACTION || deployAction == this.REDEPLOY_ACTION)
                  {
                     // Copy the archive into the autoload dir
                     VFS.copy(urlNode, urlTarget);
                     // Adds the url to the list of the archives deployed
                     if(!jonasLauncher.containsDeployedUrl(urlTarget))
                     {
                        jonasLauncher.addDeployedUrl(urlTarget);
                        newDeployment = true;
                     }
                     // if archive is an ejbjar
                     if(isEjbJar == true)
                     {
                        PathSet clientLib = PathSetManager.getLibrary(getServer().getClientLibraryName());
                        // Update of the client classpath to add the ejbjar
                        clientLib.setClassPath(clientLib.addUniquePath(clientLib.getClassPath(),
                                                                       urlTarget));
                        clientLib.save();
                        isEjbJar = false;
                     }

                     if(newDeployment == true)
                     {
                        // New archive to deploy
                        process = jRun.startJavaProcess(JonasRessource.get("JONAS_CLASS_ADMIN") + " " +
                                                        JonasRessource.get("ADMIN_ADD_OPTION"),
                                                        urlTarget.getFile());
                        process.waitFor();
                     }
                     else
                     {
                        // Call JonasAdmin to take this new archive
                        process = jRun.startJavaProcess(JonasRessource.get("JONAS_CLASS_ADMIN") + " " +
                                                        JonasRessource.get("ADMIN_REMOVE_OPTION"),
                                                        urlTarget.getFile());
                        process.waitFor();
                        process = jRun.startJavaProcess(JonasRessource.get("JONAS_CLASS_ADMIN") + " " +
                                                        JonasRessource.get("ADMIN_ADD_OPTION"),
                                                        urlTarget.getFile());
                        process.waitFor();
                     }
                  }
                  // IF UNDEPLOY ACTION
                  else if(deployAction == this.UNDEPLOY_ACTION)
                  {
                     // Remove the bean of the container jonas
                     process = jRun.startJavaProcess(JonasRessource.get("JONAS_CLASS_ADMIN") + " " +
                                           JonasRessource.get("ADMIN_REMOVE_OPTION"),
                                           urlTarget.getFile());
                     // Waits for the end of the process
                     process.waitFor();

                     if(jonasLauncher.containsDeployedUrl(urlTarget))
                     {
                        jonasLauncher.removeDeployedUrl(urlTarget);
                     }
                     if(VFS.exists(urlTarget))
                     {
                        try
                        {
                           VFS.delete(urlTarget);
                        }
                        catch(Exception e)
                        {
                           e.printStackTrace();
                        }
                     }
                  }
               }
            }
            catch(Exception exception)
            {
               exception.printStackTrace();
            }
         }
      }
      catch(Exception e)
      {
         e.printStackTrace();
      }
      finally
      {
         archivePath = null;
         archiveExtension = null;
         archiveName = null;
         urlNode = null;
         urlTarget = null;
         archiveNodeArray = null;
         deployableNodesList = null;
         jRun = null;
         process = null;
      }

   }

   /**
    * This function is used to figure out which deploy actions the associated
    * Server supports -- by default all deploy actions are supported. Some
    * Servers, however, have restrictions on their deploy capabilities. This
    * value is used, for instance, to add the right click deploy actions on a
    * node, based on which actions are supported. The value is the result of
    * a logical OR (|) of the supported deployActions found in this class
    * (static members named _ACTION)
    *
    * @param deployNodes an ArrayList of FileNodes to be deployed
    * @return an int specifying all supported deploy actions for this Service.
    */
   public int getSupportedDeployActions(ArrayList deployNodes)
   {
      return this.DEPLOY_ACTION | this.UNDEPLOY_ACTION | this.REDEPLOY_ACTION | this.LIST_ACTION;
   }





   public JavaProcess createJavaProcess()
{
return super.createJavaProcess();
}

    public java.util.SortedMap customizeOtherEarContent(Node earNode, java.util.SortedMap content)
 {
    return super.customizeOtherEarContent(earNode, content);
 }

    public void finishDeployAction(com.borland.jbuilder.runtime.ejb.DeployJavaProcessTracker tracker, JBProject jbProject, int deployAction)
 {
    super.finishDeployAction(tracker, jbProject, deployAction);
 }

    public GlobalBooleanProperty getAddProjectLibrariesOnDeployGlobalProperty()
 {
    return super.getAddProjectLibrariesOnDeployGlobalProperty();
 }

    public MultipleNodeProperty getAddProjectLibrariesOnDeployNodeProperty()
 {
    return super.getAddProjectLibrariesOnDeployNodeProperty();
 }

    public GlobalBooleanProperty getAddProjectOutputPathOnDeployGlobalProperty()
 {
    return super.getAddProjectOutputPathOnDeployGlobalProperty();
 }

    public MultipleNodeProperty getAddProjectOutputPathOnDeployNodeProperty()
 {
    return super.getAddProjectOutputPathOnDeployNodeProperty();
 }
    public java.util.List getAllDeployableNodeNames(Project project, boolean mustExist)
 {
    return super.getAllDeployableNodeNames(project, mustExist);
 }
    public java.util.List getAllDeployableNodes(Project project)
 {
    return super.getAllDeployableNodes(project);
 }
    public Node getCompanionNode(Node node)
 {
    return super.getCompanionNode(node);
 }
    public FileNode getDeployableNode(Node node)
 {
    return super.getDeployableNode(node);
 }
    public PropertyPageFactory getDeployPropertyPageFactory(Node node)
 {
    return super.getDeployPropertyPageFactory(node);
 }
    public RunConfiguration getDeployRunConfiguration(java.util.ArrayList deployNodes, int deployAction, JBProject project)
 {
    return super.getDeployRunConfiguration(deployNodes, deployAction, project);
 }

    public java.lang.String[] getEnvironment(Project project)
 {
    return super.getEnvironment(project);
 }

    public java.lang.String[] getExcludeDeployableNodeReasons(Project project, Url[] nodes)
 {
    return super.getExcludeDeployableNodeReasons(project, nodes);
 }

    public PropertyPage getProjectPropertiesPage(Project project)
 {
    return super.getProjectPropertiesPage(project);
 }

    public boolean preStartDeployAction(com.borland.jbuilder.runtime.ejb.DeployJavaProcessTracker tracker, JBProject jbProject, int deployAction)
    {
       return super.preStartDeployAction(tracker, jbProject, deployAction);
    }
    public boolean supportsDeployAtServerStartup()
    {
       return super.supportsDeployAtServerStartup();
    }

    public boolean supportsGuiToolDeploy()
 {
    return super.supportsGuiToolDeploy();
 }

}