package test;

import java.io.BufferedReader;
import java.io.File;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import com.borland.jbuilder.debugger.DebugPropertyGroup;
import com.borland.jbuilder.node.JBProject;
import com.borland.jbuilder.node.JarFileNode;
import com.borland.jbuilder.paths.JDKPathSet;
import com.borland.jbuilder.paths.PathSet;
import com.borland.jbuilder.paths.PathSetManager;
import com.borland.jbuilder.runtime.JavaProcess;
import com.borland.jbuilder.runtime.RunJavaProcessTracker;
import com.borland.jbuilder.runtime.ServerRunner;
import com.borland.jbuilder.server.DeployService;
import com.borland.jbuilder.server.PureJavaServerLauncher;
import com.borland.jbuilder.server.Server;
import com.borland.primetime.ide.Browser;
import com.borland.primetime.node.Node;
import com.borland.primetime.util.CommandRunner;
import com.borland.primetime.util.VetoException;
import com.borland.primetime.util.Wait;
import com.borland.primetime.vfs.Url;
import com.borland.primetime.vfs.VFS;
import com.borland.primetime.util.Platform;

/**
 * <p>Titre : </p>
 * <p>Description : </p>
 * <p>Copyright : Copyright (c) 2003</p>
 * <p>Socit : </p>
 * @author non attribuable
 * @version 1.0
 */

public class JonasLauncher extends PureJavaServerLauncher
{
   private JBProject m_Project;
   private ArrayList m_ArchiveDeployed = new ArrayList();

   /**
    * Constructor
    * @param p_JonasServer The server
    */
   public JonasLauncher(Server p_JonasServer)
   {
      super(p_JonasServer);
   }

   /**
    * Post tasks
    */
   public void postStop()
   {
      // Delete the client library and recreate it to delete the path of the
      // ejbjars
      PathSetManager.getLibrary(getServer().getClientLibraryName()).delete();
      getServer().createClientLibrary(getServer().getHomeDirectory().getFile());

      // Deletes the deployed files
      Url archive = null;
      Iterator i = null;
      for(i = m_ArchiveDeployed.iterator(); i.hasNext();)
      {
         archive = (Url)i.next();
         if(VFS.exists(archive))
         {
            try
            {
               VFS.delete(archive);
            }
            catch(Exception e)
            {
               e.printStackTrace();
            }
         }
      }
      m_ArchiveDeployed.clear();
   }

   /**
    * This function is called before the server process is launched. It gives a
    * server a chance to do some pre-startup tasks, if necessary. The server
    * can return false to abort the normal startup process.
    *
    * @return boolean indicating whether the appserver can be run.
    */
   public boolean preStart()
   {
      String archivePath = null;
      String archiveExtension = null;
      String archiveName = null;
      String archives[] = null;
      JonasDeployService deployService = null;
      Url urlNode = null;
      Url urlTarget = null;
      List listNodes = null;
      Node archiveNodeArray[] = null;
      Iterator deployableNodesList = null;
      int nbArchivesToDeploy = 0;
      int index = 0;
      boolean deployable = false;
      boolean isEjbJar = false;

      try
      {
         deployService = (JonasDeployService)DeployService.getService(m_Project);
         // Gets the list of nodes that can be deployed
         listNodes = deployService.getAllDeployableNodes(m_Project);
         // Gets the name of the archives to deploy
         archives = super.getArchivesToDeployOnRun();
         for(deployableNodesList = listNodes.iterator(); deployableNodesList.hasNext();)
         {
            // Contains the node and his companion Node
            archiveNodeArray = (Node[])deployableNodesList.next();
            archivePath = ((JarFileNode)archiveNodeArray[1]).getUrl().getFile();
            archiveName = archivePath.substring(archivePath.lastIndexOf("/") + 1);
            nbArchivesToDeploy = archives.length;
            index = 0;
            deployable = false;
            while(index < nbArchivesToDeploy && deployable == false)
            {
               if(archives[index].equals(archiveName))
               {
                  deployable = true;
               }
               index++;
            }

            if(deployable)
            {
               archiveExtension = archiveName.substring(archiveName.indexOf(".") + 1);
               urlNode = new Url("file", String.valueOf(((JarFileNode)archiveNodeArray[1]).getUrl().getFile()));
               if(archiveExtension.equalsIgnoreCase(JarFileNode.EXTENSION))
               {
                  // EjbJar
                  isEjbJar = true;

                  urlTarget = new Url("file",
                                      String.valueOf(this.getServer().getHomeDirectory().getFile()) +
                                      String.valueOf(File.separatorChar + "ejbjars" +
                                                     File.separatorChar + "autoload" +
                                                     File.separatorChar + archiveName));
               }
               else if(archiveExtension.equalsIgnoreCase(JarFileNode.WAR_EXTENSION))
               {
                  // WAR
                  urlTarget = new Url("file",
                                      String.valueOf(this.getServer().getHomeDirectory().getFile()) +
                                      String.valueOf(File.separatorChar + "webapps" +
                                                     File.separatorChar + "autoload" +
                                                     File.separatorChar + archiveName));
               }
               else if(archiveExtension.equalsIgnoreCase(JarFileNode.EAR_EXTENSION))
               {
                  // EAR
                  urlTarget = new Url("file",
                                      String.valueOf(this.getServer().getHomeDirectory().getFile()) +
                                      String.valueOf(File.separatorChar + "apps" +
                                                     File.separatorChar + "autoload" +
                                                     File.separatorChar + archiveName));
               }
               else if(archiveExtension.equalsIgnoreCase(JarFileNode.RAR_EXTENSION))
               {
                  // RAR
                  urlTarget = new Url("file",
                                      String.valueOf(this.getServer().getHomeDirectory().getFile()) +
                                      String.valueOf(File.separatorChar + "rars" +
                                                     File.separatorChar + "autoload" +
                                                     File.separatorChar + archiveName));
               }

               try
               {
                  if(urlTarget != null)
                  {
                     // Copy the archive into the autoload dir
                     VFS.copy(urlNode, urlTarget);
                     // Adds the url to the list of the archives deployed
                     m_ArchiveDeployed.add(urlTarget);
                     // if archive is an ejbjar
                     if(isEjbJar == true)
                     {
                        PathSet clientLib = PathSetManager.getLibrary(getServer().getClientLibraryName());
                        // Update of the client classpath to add the ejbjar
                        clientLib.setClassPath(clientLib.addUniquePath(clientLib.getClassPath(), urlTarget));
                        clientLib.save();
                        isEjbJar = false;
                     }
                  }
               }
               catch(Exception exception)
               {
                  exception.printStackTrace();
               }
            }
         }
      }
      catch(Exception e)
      {
         e.printStackTrace();
      }
      finally
      {
         archivePath = null;
         archiveExtension = null;
         archiveName = null;
         archives = null;
         deployService = null;
         urlNode = null;
         urlTarget = null;
         listNodes = null;
         archiveNodeArray = null;
         deployableNodesList = null;
      }
      return true;
   }

   /**
    * Configures this particular launcher instance with a set of services to
    * simulate a run. This service set is not validated, and the propertyMap,
    * tracker, and workDir fields are set to null.
    *
    * @param project The project using this server
    * @param propertyMap Arrays of services, no duplicates, no particular
    * order; should not be empty, should not be null
    * @param tracker
    * @param workDir
    *
    * @throws VetoException
    */
   public void configureLauncher(JBProject project,
                                 java.util.Map propertyMap,
                                 RunJavaProcessTracker tracker,
                                 Url workDir)
                                 throws VetoException
   {
      m_Project = project;
      super.configureLauncher(project, propertyMap,tracker, workDir);
   }

   /**
    * This function returns the default VM parameters
    *
    * @return String The VM parameters
    */
   public String getDefaultVmParameters()
   {
      StringBuffer st = new StringBuffer();
      st.append("-Dinstall.root=").append(this.getServer().getDefaultHomeDirectory().getFile());
      st.append(" -Djonas.base=").append(this.getServer().getDefaultHomeDirectory().getFile());
      st.append(" -Djava.security.policy=");
      st.append(this.getServer().getDefaultHomeDirectory().getFile()).append("/conf/java.policy");
      st.append(" -Dobjectweb.orb=RMI");
      st.append(" -Djonas.classpath=");
      st.append(" -Djonas.default.classloader=true");
      return st.toString();
   }

   /**
    * These VM parameters are ones without which the server will not run. Unless
    * it is really necessary, you don't want to resort to using this function.
    * These params will not be shown to the user in any UI, and will be added to
    * the front of the VM parameter list for the server, when it will be run.
    *
    * @return the vm parameters without which this server cannot be run; may be
    * an empty string, but should not be null
    */
   public String getDefaultNecessaryVmParameters()
   {
      return "";
   }

   /**
    *
    * @return the arguments with which this server should be run; may be an
    * empty string, but should not be null.
    */
   public String getDefaultArguments()
   {
      return "";
   }

   /**
    * These arguments are ones without which the server will not run. Unless it
    * is really necessary, you don't want to resort to using this function.
    * These args will not be shown to the user in any UI, and will be added to
    * the front of the argument list for the server, when it will be run.
    *
    * @return the arguments without which this server cannot be run; may be
    * an empty string, but should not be null.
    */
   public String getDefaultNecessaryArguments()
   {
      return "";
   }

   public void preStop()
   {
      forceShutdown();
   }

   /**
    * It is the class that must be launch to start the server
    * @return String The name of the class(es)
    */
   public String getDefaultClassName()
   {
      return JonasRessource.get("JONAS_CLASS_START");
   }

   /**
    *
    * @return String The command
    */
   public String getCommand()
   {
      return "";
   }


   /**
    * Returns the class Path without char [ ]
    * @return String classPath
    */
   private String getClassPath()
   {
       String temp = null;
       int indexDebut = 0;
       int indexFin = 0;

       Url classPathUrl[] = getServer().getClassPath();
       StringBuffer classPath = new StringBuffer();
       for(int i = 0; i < classPathUrl.length; i++)
       {
          temp = classPathUrl[i].getFile();
          indexDebut = temp.indexOf("[");
          if(indexDebut != -1)
          {
             temp = temp.substring(indexDebut + 1);
          }
          indexFin = temp.indexOf("]");
          if(indexFin != -1)
          {
             temp = temp.substring(0, indexFin);
          }
          classPath.append(temp).append(File.pathSeparatorChar);
       }
       return classPath.toString();
    }


   public boolean forceShutdown()
   {
      ServerRunner.removeRunningLauncher(this);
      if(DebugPropertyGroup.isRemoteAttach(getPropertyMap()))
      {
         return false;
      }
      JonasStopper stopper = new JonasStopper(this);
      if(stopper != null)
      {
         Wait wait = new Wait(stopper.getWaitTime() * 1000);
         Thread thread = new Thread(stopper, "Sending stop to server");
         thread.start();
         try
         {
            do
            {
               Thread.sleep(250L);
            }
            while(stopper.sendingStop() && !wait.done());
         }
         catch(InterruptedException interruptedexception)
         {
            return false;
         }
         if(wait.done())
         {
            thread.interrupt();
         }
         return stopper.stopSent();
      }
      else
      {
         return false;
      }
   }

   protected com.borland.jbuilder.server.ServerLauncher.Stopper getStopper()
   {
      return null;
   }

   class JonasStopper implements com.borland.jbuilder.server.ServerLauncher.Stopper
   {
      private final JonasLauncher m_Launcher;
      boolean c;
      boolean b;

      /**
       * Constructor
       * @param ajonaslauncher JonasLauncher
       */
      JonasStopper(JonasLauncher ajonaslauncher)
      {
         m_Launcher = ajonaslauncher;
         b = true;
         c = false;
      }

      public boolean stopSent()
      {
         return c;
      }

      public boolean sendingStop()
      {
         return b;
      }

      /**
       * Returns the time to wait
       * @return int
       */
      public int getWaitTime()
      {
         return 100;
      }

      /**
       * Run method
       */
      public void run()
      {
         try
         {
            String s = makeCommandLine(m_Launcher.getTracker().getBrowser(), m_Launcher.getServer());
            try
            {
               Process process = CommandRunner.exec(s);

               BufferedReader bufferedreader = new BufferedReader(new InputStreamReader(process.getInputStream()));
               BufferedReader bufferedreader1 = new BufferedReader(new InputStreamReader(process.getErrorStream()));
               do
               {
                  try
                  {
                     c = process.exitValue() == 0;
                     break;
                  }
                  catch(IllegalThreadStateException illegalthreadstateexception)
                  {
                     //for(; bufferedreader.ready(); JonasLauncher.a(a).javaProcessSent(null, String.valueOf(String.valueOf(bufferedreader.readLine())).concat("\n\r"), false));
                     //for(; bufferedreader1.ready(); JonasLauncher.a(a).javaProcessSent(null, String.valueOf(String.valueOf(bufferedreader1.readLine())).concat("\n\r"), true));
                     Thread.sleep(50L);
                  }
               }
               while(true);
               //for(; bufferedreader.ready(); JonasLauncher.a(a).javaProcessSent(null, String.valueOf(String.valueOf(bufferedreader.readLine())).concat("\n\r"), false));
               //for(; bufferedreader1.ready(); JonasLauncher.a(a).javaProcessSent(null, String.valueOf(String.valueOf(bufferedreader1.readLine())).concat("n\r"), true));
            }
            catch(Exception exception)
            {}
         }
         finally
         {
            b = false;
         }
      }

      /**
       * Creates the command line to stop jonas
       * @param browser
       * @param server
       * @return String the command line
       */
      private String makeCommandLine(Browser browser, Server server)
      {
         Object obj = null;
         char c1 = File.pathSeparatorChar;
         JDKPathSet jdkpathset = server.getAssociatedJdk();
         if(jdkpathset == null)
         {
            com.borland.primetime.node.Project project = browser.getActiveProject();
            if(project instanceof JBProject)
            {
               jdkpathset = ((JBProject) project).getPaths().getJDKPathSet();
            }
            else
            {
               jdkpathset = PathSetManager.getJDK("");
            }
         }
         StringBuffer stringbuffer = new StringBuffer();
         stringbuffer.append(jdkpathset.getHomePath().getFile());
         stringbuffer.append(File.separatorChar).append("bin").append(File.separatorChar);
         stringbuffer.append(JavaProcess.getJavaLauncher());
         String s = server.getHomeDirectory().getFile();
         StringBuffer stringbuffer1 = new StringBuffer(" -classpath ");
         stringbuffer1.append(getClassPath());
         stringbuffer.append(stringbuffer1.toString());
         stringbuffer.append(" ").append(getVmParameters()).append(" ");
         stringbuffer.append(JonasRessource.get("JONAS_STOP_CLASSES"));
         return stringbuffer.toString();
      }
   }

   public void addDeployedUrl(Url p_Url)
   {
      m_ArchiveDeployed.add(p_Url);
   }

   public boolean containsDeployedUrl(Url p_Url)
   {
      return m_ArchiveDeployed.contains(p_Url);
   }

   public Iterator getDeployedUrl()
   {
      return m_ArchiveDeployed.iterator();
   }

   public void removeDeployedUrl(Url p_Url)
   {
      m_ArchiveDeployed.remove(p_Url);
   }

}