/****************************************************************************
 * Copyright (C) year 2001 Cyrille Morvan (Ingenosya France)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 ****************************************************************************/

package test;

import java.util.ListResourceBundle;
import java.util.ResourceBundle;

/**
 * Langage ressource for JOnAS Open Tool.
 * <br>
 *
 * Titre :        JBuilder OpenTools for Jonas.
 * Text ressource
 * Copyright :    Copyright (c) 2001
 * Company :      <a href="http://www.ingenosya.com">Ingenosya</a>
 * @author Cyrille Morvan <a href="mailto:cmorvan@ingenosya.com">cmorvan@ingenosya.com</a>
 *        <a href="mailto:morvan@fiifo.u-psud.fr">morvan@fiifo.u-psud.fr</a>
 * @version 1.0
 */
public class JonasRessource extends ListResourceBundle
{

   public static final String COMMERCIAL_NAME = "Kelly";

   public static final String KELLY_VERSION = "1.6";

   private static ResourceBundle res = ResourceBundle.getBundle(JonasRessource.class.getName());

   private static final Object[][] contents = {
   { "AUTHORS" , "Philippe Charaux <philippe.charaux@bull.net>" },
   // Server name
   { "SERVER_NAME" , "JOnAS" },
   // Server version
   { "SERVER_VERSION", "3" },
   { "JONAS_DEFAULT_HOMEDIR", "c:/jonas/" },
   { "JONAS_CLASS_START", "org.objectweb.jonas.server.Bootstrap org.objectweb.jonas.server.Server" },
   { "JONAS_CLASS_ADMIN", "org.objectweb.jonas.server.Bootstrap org.objectweb.jonas.adm.JonasAdmin" },
   { "ADMIN_REMOVE_OPTION", " -r" },
   { "ADMIN_ADD_OPTION", " -a" },
   { "ADMIN_LIST_OPTION", " -l" },

   // GenIC
   { "GENIC_CLASSES", "org.objectweb.jonas.server.Bootstrap org.objectweb.jonas_ejb.genic.GenIC" },
   { "GENIC_NOADDINJAR", "-noaddinjar" },
   { "GENIC_FILE", "GenICTmpJarU" },


   // for targeting
   { "JONAS_STOP_CLASSES" , "org.objectweb.jonas.server.Bootstrap org.objectweb.jonas.adm.JonasAdmin -s" },
   { "JSP_CLASS" , "org.apache.jasper.runtime.HttpJspBase" },

   // <wizard> :
   { "CMD_LABEL" , "GenIC JOnAS Deployer" },

   // page 1 : select jar
   { "TITLE_JAR", "Step 1 : list of EJB to deploy." },
   { "INSTRUCTION_JAR", "Add or remove all the EJB you want to deploy." },
   { "EDIT" , "Edit" },

   { "CHOOSER_EJB_TITLE","Add one or more jar to the list"},
   { "ALL_FILES" , "All files"},
   { "JAR_FILES" , "Jar Files (EJB)" },
};

   public JonasRessource() {
   }

   public static String get(String aString) {
      return res.getString(aString);
   }

   public static String getDefaultName() {
      StringBuffer aStringBuffer = new StringBuffer();
      aStringBuffer.append(JonasRessource.get("SERVER_NAME"));
      aStringBuffer.append(' ');
      aStringBuffer.append(JonasRessource.get("SERVER_VERSION"));
      return aStringBuffer.toString();
   }


   public Object[][] getContents() {
      return contents;
   }
}
