package test;

import java.io.File;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Iterator;
import com.borland.jbuilder.build.ExternalBuildTask;
import com.borland.jbuilder.node.JBProject;
import com.borland.jbuilder.runtime.RunJavaProcess;
import com.borland.jbuilder.server.EjbService;
import com.borland.primetime.util.OSEnvironment;
import com.borland.primetime.vfs.Url;
import com.borland.primetime.vfs.VFS;
import com.borland.jbuilder.server.Server;


/**
 * Class that encapsulate the call to startjavaprocess from RunJavaProcess.
 * It gets all the parameters needed by the process
 *
 * <p>Titre : JBuilder OpenTools for EJB deployment on Jonas</p>
 * <p>Description : </p>
 * <p>Copyright : Copyright (c) 2003</p>
 * <p>Socit : </p>
 * @author non attribuable
 * @version 1.0
 */
public class JonasRun extends RunJavaProcess
{
   private JBProject m_JbProject;

   /**
    * Constructor
    * @param jbproject
    */
   public JonasRun(JBProject jbproject)
   {
      m_JbProject = jbproject;
      //g();
      //setEnvironmentVariable(ExternalBuildTask.getPathEnvVariable() + ";D:/Temp/jonas/lib/common/ow_jonas_bootstrap.jar;", null);
   }


   /**
    * Starts the java process and gets the other parameters
    *
    * @param p_ClassToRun
    * @param jarName
    * @return Process
    */
   public Process startJavaProcess(String p_ClassToRun, String jarName)
   {
      m_JbProject.getPaths().putClassOnFullPath(p_ClassToRun);
      File launcherPath = getJdkHomePath().getFileObject();
      Url url = new Url(launcherPath);
      if(!VFS.exists(url.getRelativeUrl("bin")) && VFS.exists(url.getRelativeUrl("jre")))
      {
         launcherPath = url.getRelativeUrl("jre").getFileObject();
      }
      //String as[] = d();
      String as[] = null;
      // Recupere le repertoire temporaire
      File workTempDir = getTempUrl().getFileObject();
      return startJavaProcess(launcherPath, p_ClassToRun, getClassPath(), getJavaParams(), jarName, as, workTempDir);
   }

   /**
    * Gets the temp dir
    * @return Url pointing to the tempDir
    */
   private Url getTempUrl()
   {
      String tempDir = System.getProperty("java.io.tmpdir") + "genic";
      File genicTemp = new File(tempDir);
      genicTemp.mkdir();
      return new Url(new File(tempDir));
   }

   /**
    * Returns the java parameters for the server
    * @return String the parameters
    */
   private String getJavaParams()
   {
      EjbService ejbservice = EjbService.getService(m_JbProject);
      Server server = ejbservice.getServer();
      return server.getSetupLauncher().getVmParameters();
   }

   /**
    * Returns the home path of java
    * @return Url
    */
   private Url getJdkHomePath()
   {
      return m_JbProject.getPaths().getJDKPathSet().getHomePath();
   }

   /**
    * Returns the class path
    * @return String the classpath
    */
   private String getClassPath()
   {
      String temp = null;
      int indexDebut = 0;
      int indexFin = 0;
      EjbService ejbservice = EjbService.getService(m_JbProject);
      Server server = ejbservice.getServer();
      Url classPathUrl[] = server.getClassPath();
      StringBuffer classPath = new StringBuffer();
      for(int i = 0; i < classPathUrl.length; i++)
      {
         temp = classPathUrl[i].getFile();
         indexDebut = temp.indexOf("[");
         if(indexDebut != -1)
         {
            temp = temp.substring(indexDebut + 1);
         }
         indexFin = temp.indexOf("]");
         if(indexFin != -1)
         {
            temp = temp.substring(0, indexFin);
         }
         classPath.append(temp).append(File.pathSeparatorChar);
      }
      return classPath.toString();
   }
}
