package test;

import java.io.File;
import java.awt.Component;
import com.borland.jbuilder.server.Server;
import com.borland.jbuilder.server.ServerLauncher;
import com.borland.jbuilder.server.ServerManager;
import com.borland.jbuilder.server.ServerPropertyGroup;
import com.borland.primetime.vfs.Url;
import com.borland.primetime.vfs.VFS;


/**
 * <p>Titre : </p>
 * <p>Description : </p>
 * <p>Copyright : Copyright (c) 2003</p>
 * <p>Socit : </p>
 * @author non attribuable
 * @version 1.0
 */

public class JonasServer extends Server
{

   /**
    * Constructor
    */
   public JonasServer(String p_ServerName)
   {
      super(p_ServerName);
   }

   /**
    *
    * @param byte0
    * @param byte1
    */
   public static void initOpenTool(byte byte0, byte byte1)
   {
      if(com.borland.jbuilder.info.JBuilderInfo.isEnterpriseEnabled())
      {
         ServerManager.registerServer(new JonasServer(JonasRessource.get("SERVER_NAME")));
      }
   }

   /**
    * Registers the server's services
    */
   public void registerServices()
   {
      ServerManager.registerService(new JonasEjbService(this));
      ServerManager.registerService(new JonasJspServletService(this));
      ServerManager.registerService(new JonasDeployService(this));
      ServerManager.registerService(new JonasNamingService(this));
      ServerManager.registerService(new JonasMessageService(this));
   }

    // Mthodes  implmenter de l'interface Server

    /**
     * @return name used to refer to the Server. Should not be null.
     */
    public String getDefaultName()
    {
       return JonasRessource.get("SERVER_NAME");
    }

    /**
     * @return version used to refer to the Server -- this string cannot
     * contain any spaces. Should not be null.
     */
    public String getDefaultVersion()
    {
        return JonasRessource.get("SERVER_VERSION");
    }

    /**
     * This function returns the default home directory for this Server
     *
     * @return Url with the default home directory for this Server.
     * Should not be null.
     */
    public Url getDefaultHomeDirectory()
    {
        return new Url("file", JonasRessource.get("JONAS_DEFAULT_HOMEDIR"));
    }

    /**
     * This function returns the array of default directories/.jars that are
     * necessary to run this Server. The user will be able to modify this list.
     *
     * @return Url[] The default classpath for this Server
     */
    public Url[] getDefaultClassPath()
    {
        Url aurl[] = new Url[2];
        // Rcupration du Home directory
        String homeDir = getDefaultHomeDirectory().getFile();
        // Terminaison de la chaine avec /
        if(!homeDir.endsWith("/"))
        {
           homeDir = String.valueOf(homeDir) + String.valueOf('/');
        }

        // Ajout des lib ncessaires dans le classpath
        aurl[0] = new Url("zip", String.valueOf((new StringBuffer(String.valueOf(String.valueOf('[')))).append(homeDir).append("lib/common/ow_jonas_bootstrap.jar]")));
        // Ajout de repertoire de config de JOnAS
        aurl[1] = new Url("zip", String.valueOf((new StringBuffer(String.valueOf(String.valueOf('[')))).append(homeDir).append("conf]")));

        return aurl;
    }

    /**
     * This function is useful if the Server has to be configured before it can
     * actually be used. It lets the Server return a string that indicates why
     * the setup directory might be invalid. In most cases the setupDirectory
     * will be the homeDirectory of the Server. If there are no problems, the
     * return value is null.
     *
     * @param p_SetupDir The directory used to configure the Server (its home)
     *
     * @return A string indicating why the directory is invalid.
     */
    public String isValidSetupDirectory(String p_SetupDir)
    {
       if(!p_SetupDir.endsWith("/"))
       {
          p_SetupDir = String.valueOf(p_SetupDir) + String.valueOf('/');
       }
       String exists = getFile(p_SetupDir, "lib/web_catalina.jar");
       if(exists == null)
       {
          exists = getFile(p_SetupDir, "lib/RMI_client.jar");
       }
       if(exists == null)
       {
          if(!libraryExists(getClientLibraryName()))
          {
             createClientLibrary(p_SetupDir);
          }
       }
       return exists;
    }

    /**
     * Factory method that returns a new instance of a ServerLauncher
     * associated with this particular server setup. Run configuration settings
     * are applied to this newly created instance. Not that you wouldn't, but
     * Server implementions must return instances of the same type of
     * ServerLauncher implementation. Don't get fancy and dynamically generate
     * different types on ServerLauncher depending on setup/config state.
     *
     * @return a new instance
     */
    public ServerLauncher newLauncher()
    {
       return new JonasLauncher(this);
    }

    /**
     * The debugger needs the names of the packages that comprise the server
     * so that tracing for those classes can be disabled. The package names
     * may include a trailing asterisk as a wildcard
     *
     * @return array of package names
     */
    public String[] getPackages()
    {
       String packages[] = new String[1];
       packages[0] = "org.objectweb.jonas.server.*";
       return packages;
    }

    // FIN Mthodes  implmenter de l'interface


    /**
     * Override this function to return a classpath containing classes necessary
     * for a client application to access this application server.
     *
     * @param p_InstallPath - Directory where Server is installed. This is
     * passed just in case the home directory hasn't been updated yet with the new path.
     *
     * @return Url[] Containing valid classpath entries for the client library.
     */
    public Url[] getClientLibraryClassPath(String p_InstallPath)
    {
        if(p_InstallPath == null || p_InstallPath.equals(""))
        {
            p_InstallPath = getHomeDirectory().getFile();
        }
        String installPath = p_InstallPath.endsWith("/") ? p_InstallPath : String.valueOf(p_InstallPath) + String.valueOf('/');
        Url aurl[] = new Url[2];
        aurl[0] = new Url("zip", String.valueOf(String.valueOf((new StringBuffer(String.valueOf(String.valueOf('[')))).append(installPath).append("lib/web_catalina.jar").append(']'))));
        aurl[1] = new Url("zip", String.valueOf(String.valueOf((new StringBuffer(String.valueOf(String.valueOf('[')))).append(installPath).append("lib/RMI_client.jar").append(']'))));
        return aurl;
    }

    /**
     * Checks that the server can be started; in particular by knowing where
     * the server JARs are.
     *
     * @return whether server is configured.
     */
    public boolean isSetup()
    {
        boolean flag = ServerPropertyGroup.isEnterpriseFunctionalityAvailable();
        if(flag && (getHomeDirectory() == null || !VFS.exists(getHomeDirectory()) || !libraryExists(getClientLibraryName())))
        {
           flag = false;
        }
        JonasSettings.setValue("SETUP", "true");
        return flag;
     }

    /**
     * Return null or the message why the file does not exist
     * @param p_StartPath
     * @param p_EndPath
     * @return String
     */
    private String getFile(String p_StartPath, String p_EndPath)
    {
       String s2 = null;
       File file = new File(String.valueOf(p_StartPath) + String.valueOf(p_EndPath));
       if(!file.exists())
       {
          s2 = String.valueOf(file.getAbsoluteFile()) + " is required";
       }
       return s2;
    }

    /**
     * This function checks if this Server has been configured. If not
     * configured, and a CustomConfigurationPage exists for this Server
     * (or it is just required to go through the Configure Servers dialog),
     * a message dialog will come up indicating that this Server has not been
     * configured yet.
     *
     * @param p_Component The host to use for the message dialog that might
     * come up as a result of this function call
     *
     * @return true if the user needs to go through the Configure Servers
     * dialog and if the configuration has been completed successfully,
     * false otherwise.
     */
    public boolean checkSetup(Component p_Component)
    {
       return true;
    }

}
