package test;

import java.io.File;
import com.borland.jbuilder.build.BuildMessage;
import com.borland.jbuilder.build.BuildReport;
import com.borland.jbuilder.build.CommandMaker;
import com.borland.jbuilder.build.ExternalBuildTask;
import com.borland.jbuilder.enterprise.ejb.AppServerTargeting;
import com.borland.jbuilder.enterprise.ejb.DeploymentDescriptor;
import com.borland.jbuilder.info.JBuilderInfo;
import com.borland.jbuilder.node.EJBGRPFileNode;
import com.borland.jbuilder.node.JBProject;
import com.borland.jbuilder.node.JarFileNode;
import com.borland.jbuilder.server.ServerManager;
import com.borland.primetime.build.BuildProcess;
import com.borland.primetime.ide.Browser;
import com.borland.primetime.util.CommandRunner;
import com.borland.primetime.util.Strings;
import com.borland.primetime.vfs.Url;
import com.borland.primetime.vfs.VFS;

/**
 *
 * <p>Titre : </p>
 * <p>Description : </p>
 * <p>Copyright : Copyright (c) 2003</p>
 * <p>Socit : </p>
 * @author non attribuable
 * @version 1.0
 */

public class JonasTargeting extends AppServerTargeting
{
   private boolean a;

   /**
    * Constructor
    */
   public JonasTargeting()
   {
      super();
   }

   /**
    * After the normal Make/Rebuild process generates the deployable jar,
    * perform any needed postprocessing.
    *
    * @param buildprocess The build process that built jar from the EJB Group file
    * @param ejbgrpfilenode The EJB Group file node
    * @param jarfilenode Node for the jar file
    */
   public void postProcessBuild(BuildProcess buildprocess, EJBGRPFileNode ejbgrpfilenode,
                                JarFileNode jarfilenode)
   {
      Url jarFileUrl = null;
      Url ioTempDirUrl = null;
      StringBuffer jarUpdate = null;
      String ioTempDir = null;
      CommandMaker commandmaker = null;
      JonasRun genicRun = null;
      Process genIcProcess = null;
      Process jarProcess = null;

      JBProject jbproject = (JBProject) ejbgrpfilenode.getProject();
      BuildReport buildreport = new BuildReport();
      String errorMessage = "Invocation Error for JOnAS GenIC.";
      String isSetup = (String) JonasSettings.getValue("SETUP");
      if(isSetup == null || !isSetup.equals("true"))
      {
         buildreport.addBuildError(new BuildMessage(errorMessage, 2));
      }
      if(buildreport.getErrorCount() == 0)
      {
         ioTempDir = System.getProperty("java.io.tmpdir");
         ioTempDirUrl = new Url(new File(ioTempDir));
         if(!VFS.exists(ioTempDirUrl))
         {
            String errorTempDir = Strings.format("Temporary directory does not exist: {0}",
                                                 ioTempDirUrl.getFile());
            buildreport.addBuildError(new BuildMessage(errorTempDir, 1));
         }
         jarFileUrl = jarfilenode.getUrl();
         buildprocess.fireBuildStatus(Strings.format("Running GenIC on {0}...", jarFileUrl.getName()), false);

         try
         {
            commandmaker = new CommandMaker(errorMessage);
            genicRun = new JonasRun(jbproject);
            // Start process GenIC
            // option noaddinjar to run with all versions of jonas
            // (bug GenIC for Jonas < 3.1)
            genIcProcess = genicRun.startJavaProcess(JonasRessource.get("GENIC_CLASSES") +
                                                     " " + JonasRessource.get("GENIC_NOADDINJAR"),
                                                     jarFileUrl.getFile());
            String genIcCommandLine = genicRun.getCommandLine();

            // Wait for the end of the process
            genIcProcess.waitFor();

            // A VALIDER SUR VERSION JONAS 3.1
            // if the JonasVersion is greater than 3.1 the genic bugs are corrected
            //if(JonasProperties.JONAS31_VERSION.getValue() != null &&
            //   JonasProperties.JONAS31_VERSION.getValue().equals("false"))
            //{
            // Update of the jar with the genrated files from GenIC
            jarUpdate = new StringBuffer();
            jarUpdate.append(ExternalBuildTask.findJavaTool(jbproject));
            jarUpdate.append(File.separatorChar).append("jar -uf ").append(jarfilenode.getUrl().
               getFile());
            jarUpdate.append(" *.*");

            // Delete GenICTmpJarU file
            File genicFile = new File(System.getProperty("java.io.tmpdir") + File.separatorChar +
                                      "genic" + File.separatorChar +
                                      JonasRessource.get("GENIC_FILE"));
            if(genicFile.exists())
            {
               genicFile.delete();
            }
            // Temp dir
            File tempDir = new File(System.getProperty("java.io.tmpdir") + File.separatorChar +
                                    "genic");

            // Update ejbjar
            jarProcess = CommandRunner.exec(jarUpdate.toString(), null, tempDir);
            jarProcess.waitFor();

            // Deleting temp dir
            if(tempDir.exists())
            {
               deleteFiles(tempDir.listFiles());
               tempDir.delete();
            }
            //}
            if(genIcProcess == null)
            {
               buildreport.addBuildError(new BuildMessage(errorMessage, 2));
            }
            else
            {
               commandmaker.report(buildreport, genIcProcess, genIcCommandLine);
            }
         }
         catch(Exception exception1)
         {
            buildreport.addBuildError(new BuildMessage(exception1.getMessage(), 2));
         }
         finally
         {
            jarFileUrl = null;
            ioTempDirUrl = null;
            jarUpdate = null;
            ioTempDir = null;
            commandmaker = null;
            genicRun = null;
            genIcProcess = null;
            jarProcess = null;
         }
      }
   }

   /**
    * Update the EJB Group files and return the deployment descriptors to be
    * included in the deployed jar during the Make/Rebuild process.
    *
    * @param adeploymentdescriptor Array of EJB deployment descriptors
    * @param ejbgrpfilenode The EJB Group file node.
    * @param flag True to invalidate cached descriptors
    * @param buildreport Where to accumulate error messages on conversion process.
    *
    * @return Array of deployment descriptors to be jar'ed or null if none.
    */
   public DeploymentDescriptor[] updateDeploymentDescriptors(DeploymentDescriptor adeploymentdescriptor[],
                                                             EJBGRPFileNode ejbgrpfilenode,
                                                             boolean flag,
                                                             BuildReport buildreport)
   {
      if(!a)
      {
         a = true;
         try
         {
            JonasAbstractDescriptorConversion jadc = new JonasAbstractDescriptorConversion(
               adeploymentdescriptor, ejbgrpfilenode, buildreport);
            DeploymentDescriptor adeploymentdescriptor1[] = jadc.convert(true, true, flag);
            return adeploymentdescriptor1;
         }
         catch(Exception exception)
         {
            exception.printStackTrace();
         }
         finally
         {
            a = false;
         }
      }
      return null;
   }

   /**
    * Init method that register this openTool
    *
    * @param byte0
    * @param byte1
    */
   public static void initOpenTool(byte byte0, byte byte1)
   {
      if(JBuilderInfo.isEnterpriseEnabled())
      {
         ServerManager.registerTargeting(new JonasTargeting(),
                                         JonasRessource.get("SERVER_NAME"),
                                         JonasRessource.get("SERVER_VERSION"));
      }
   }

   /**
    * Private method that delete the temporary files generated during the
    * GenIC process
    *
    * @param p_ListFile an array of files
    */
   private void deleteFiles(File[] p_ListFile)
   {
      int i;
      if(p_ListFile != null)
      {
         for(i = 0; i < p_ListFile.length; i++)
         {
            if(p_ListFile[i].exists())
            {
               if(p_ListFile[i].isFile())
               {
                  p_ListFile[i].delete();
               }
               else if(p_ListFile[i].isDirectory())
               {
                  deleteFiles(p_ListFile[i].listFiles());
                  p_ListFile[i].delete();
               }
            }
         }
      }
   }
}